    PROGRAM f04abfe

!      F04ABF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : f04abf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, lda, ldb, ldbb, ldc, m, n
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:), b(:,:), bb(:,:), c(:,:),     &
                                          wkspce(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F04ABF Example Program Results'
       WRITE (nout,*)
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, m
       lda = n
       ldb = n
       ldbb = n
       ldc = n
       ALLOCATE (a(lda,n),b(ldb,m),bb(ldbb,m),c(ldc,m),wkspce(n))
       READ (nin,*) (a(i,1:n),i=1,n), (b(i,1:m),i=1,n)

!      ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
       ifail = 0
       CALL f04abf(a,lda,b,ldb,n,m,c,ldc,wkspce,bb,ldbb,ifail)

       WRITE (nout,*) ' Solution'
       WRITE (nout,99999) (c(i,1:m),i=1,n)

99999  FORMAT (1X,F9.4)
    END PROGRAM f04abfe
